require 'spec_helper'

describe 'Rubbis', :acceptance do
	it 'actively expires keys' do
		with_server do
			n = 10
			n.times do |x|
				kkey = "keep#{x}"
				ekey = "expire#{x}"
				client.set(kkey, "123")
				client.set(ekey, "123")
				client.pexpire(ekey, rand(600))
			end
			condition = ->{
				client.keys("*").count {|x| x.start_with?("expire") } == 0
			}

			start_time = Time.now
			while !condition.call && (Time.now < start_time + 2)
				sleep 0.01
			end

			expect(condition.call).to eq(true)
			expect(client.keys('*').size).to eq(n)
		end
	end
end