require 'spec_helper'

describe 'Rubbis', :acceptance do
	it 'support pubsub' do
		with_server do 
			received = nil
			c = client

			t1 = Thread.new do
				c.subscribe("mychan") do |on|
					on.message do |channel, msg|
						received = msg
						c.unsubscribe("mychan")
					end
				end
			end

			sleep 0.1

			client.publish('mychan', 'hello')
			t1.value
			expect(received).to eq('hello')
		end
	end

	it 'supports pubsub with patterns' do
		with_server do
			received = nil
			c = client

			t1 = Thread.new do
				c.psubscribe("my.*") do |on|
					on.message do |channel, msg|
						received = msg
						c.punsubscribe("my.*")
					end
				end
			end

			sleep 0.1

			client.publish('your.chan', 'bogus')
			client.publish('my.chan', 'hello')
			t1.value
			expect(received).to eq('hello')
		end
	end
end